/* Generated by re2c 3.1 on Wed Apr 23 03:38:00 2025 */
#line 1 "../src/main.ypp"
// Copyright (c) 2024 Vinícius dos Santos Oliveira
// SPDX-License-Identifier: MIT OR BSL-1.0

#include <emilua/windows.hpp>
#include <emilua/state.hpp>

#include <fmt/ostream.h>
#include <fmt/format.h>

#include <boost/nowide/iostream.hpp>

namespace hana = boost::hana;
namespace fs = std::filesystem;

namespace emilua::main {

#if BOOST_OS_WINDOWS
extern int (*main)(int argc, char *argv[], char *envp[]);
#else // BOOST_OS_WINDOWS
int main(int argc, char *argv[], char *envp[]);
#endif // BOOST_OS_WINDOWS

static constexpr auto help_text = FMT_STRING(
    "Emilua: Execution engine for luaJIT\n"
    "Usage: {} [OPTIONS] [file]\n"
    "\n"
    "Positionals:\n"
    "  file TEXT                   Script filename\n"
    "\n"
    "Options:\n"
    "  -h,--help                   Print this help message and exit\n"
    "  --main-context-concurrency-hint INT\n"
    "                              Concurrency hint for the main execution engine context\n"
    "  --test Run tests\n"
    "  --version                   Output version information and exit\n");

static std::string filename_buffer;
static std::string_view filename;
static int main_ctx_concurrency_hint_ = 0;
static ContextType main_context_type = ContextType::main;

#if BOOST_OS_WINDOWS
extern void (*parse_args)(int argc, char *argv[], app_context& appctx);
static void parse_args2(int argc, char *argv[], app_context& appctx)
#else // BOOST_OS_WINDOWS
void parse_args(int argc, char *argv[], app_context& appctx)
#endif // BOOST_OS_WINDOWS
{
#define NEXT_ARG(OPTION, LABEL) do {                           \
        if (YYCURSOR = *++cur_arg ; YYCURSOR != nullptr) {     \
            goto LABEL;                                        \
        } else {                                               \
            try {                                              \
                boost::nowide::cerr <<                         \
                    "missing value for option `" OPTION "`\n"; \
            } catch (const std::ios_base::failure&) {}         \
            std::exit(2);                                      \
        }                                                      \
    } while(0)

#define ERRARG(OPTION)                                                     \
    do {                                                                   \
        try {                                                              \
            fmt::print(                                                    \
                boost::nowide::cerr,                                       \
                FMT_STRING(                                                \
                    "value `{}` not supported for option `" OPTION "`\n"), \
                *cur_arg);                                                 \
        } catch (const std::ios_base::failure&) {}                         \
        std::exit(2);                                                      \
    } while(0)

    if (argc <= 0) {
        try {
            boost::nowide::cerr << "missing filename\n";
        } catch (const std::ios_base::failure&) {}
        std::exit(2);
    }

    #line 87 "../src/main.ypp"

    char* YYCURSOR;
    char* YYMARKER;
    char** cur_arg = argv;
opt:
    YYCURSOR = *++cur_arg;
    if (YYCURSOR == nullptr) goto end;

#line 92 "emilua.p/main.cpp"
{
    char yych;
    yych = *YYCURSOR;
    switch (yych) {
        case 0x00: goto yy1;
        case '-': goto yy3;
        default: goto yy2;
    }
yy1:
    ++YYCURSOR;
#line 95 "../src/main.ypp"
    {
        try {
            fmt::print(boost::nowide::cerr, FMT_STRING("bad option: `{}`\n"),
                       *cur_arg);
        } catch (const std::ios_base::failure&) {}
        std::exit(2);
    }
#line 111 "emilua.p/main.cpp"
yy2:
    yych = *++YYCURSOR;
    if (yych <= 0x00) goto yy5;
    goto yy2;
yy3:
    yych = *++YYCURSOR;
    switch (yych) {
        case 0x00: goto yy6;
        case '-': goto yy7;
        default: goto yy4;
    }
yy4:
#line 141 "../src/main.ypp"
    { goto opt_short; }
#line 126 "emilua.p/main.cpp"
yy5:
    ++YYCURSOR;
#line 117 "../src/main.ypp"
    {
        if (filename.size() > 0) {
            try {
                boost::nowide::cerr <<
                    "emilua doesn't support more than one input file\n";
            } catch (const std::ios_base::failure&) {}
            std::exit(2);
        }
        filename = *cur_arg;
        fs::path as_path{widen_on_windows(filename)};
        std::error_code ignored_ec;
        if (fs::is_directory(as_path, ignored_ec)) {
            // Alternatively, we could apply this transformation inside
            // `make_master_vm()`. However if the user is using
            // `modules_cache_registry` or `get_builtin_module()` the query
            // wouldn't make sense inside `make_master_vm()`. Here's the most
            // appropriate place to perform filesystem queries and apply such
            // transformations.
            as_path /= "init.lua";
            filename_buffer = as_path.string();
            filename = filename_buffer;
        }
        goto opt;
    }
#line 154 "emilua.p/main.cpp"
yy6:
    ++YYCURSOR;
#line 111 "../src/main.ypp"
    {
        try {
            boost::nowide::cerr << "stdin not supported as input file\n";
        } catch (const std::ios_base::failure&) {}
        std::exit(2);
    }
#line 164 "emilua.p/main.cpp"
yy7:
    yych = *++YYCURSOR;
    if (yych <= 0x00) goto yy8;
#line 142 "../src/main.ypp"
    { goto opt_long; }
#line 170 "emilua.p/main.cpp"
yy8:
    ++YYCURSOR;
#line 102 "../src/main.ypp"
    {
        appctx.app_args.reserve(2 + ((argv + argc) - (cur_arg + 1)));
        appctx.app_args.emplace_back(argv[0]);
        appctx.app_args.emplace_back(filename);
        while (*++cur_arg) {
            appctx.app_args.emplace_back(*cur_arg);
        }
        goto end;
    }
#line 183 "emilua.p/main.cpp"
}
#line 143 "../src/main.ypp"


opt_short:

#line 190 "emilua.p/main.cpp"
{
    char yych;
    yych = *YYCURSOR;
    switch (yych) {
        case 0x00: goto yy10;
        case 'h': goto yy12;
        default: goto yy11;
    }
yy10:
    ++YYCURSOR;
#line 154 "../src/main.ypp"
    { goto opt; }
#line 203 "emilua.p/main.cpp"
yy11:
    ++YYCURSOR;
#line 147 "../src/main.ypp"
    {
        try {
            fmt::print(boost::nowide::cerr, FMT_STRING("bad short option: {}\n"),
                       *cur_arg);
        } catch (const std::ios_base::failure&) {}
        std::exit(2);
    }
#line 214 "emilua.p/main.cpp"
yy12:
    ++YYCURSOR;
#line 155 "../src/main.ypp"
    {
        try {
            fmt::print(boost::nowide::cout, help_text, *argv);
        } catch (const std::ios_base::failure&) {}
        std::exit(0);
    }
#line 224 "emilua.p/main.cpp"
}
#line 161 "../src/main.ypp"


opt_long:

#line 231 "emilua.p/main.cpp"
{
    char yych;
    yych = *YYCURSOR;
    switch (yych) {
        case 'h': goto yy16;
        case 'm': goto yy17;
        case 't': goto yy18;
        case 'v': goto yy19;
        default: goto yy14;
    }
yy14:
    ++YYCURSOR;
yy15:
#line 165 "../src/main.ypp"
    {
        try {
            fmt::print(boost::nowide::cerr, FMT_STRING("bad long option: {}\n"),
                       *cur_arg);
        } catch (const std::ios_base::failure&) {}
        std::exit(2);
    }
#line 253 "emilua.p/main.cpp"
yy16:
    yych = *(YYMARKER = ++YYCURSOR);
    switch (yych) {
        case 'e': goto yy20;
        default: goto yy15;
    }
yy17:
    yych = *(YYMARKER = ++YYCURSOR);
    switch (yych) {
        case 'a': goto yy22;
        default: goto yy15;
    }
yy18:
    yych = *(YYMARKER = ++YYCURSOR);
    switch (yych) {
        case 'e': goto yy23;
        default: goto yy15;
    }
yy19:
    yych = *(YYMARKER = ++YYCURSOR);
    switch (yych) {
        case 'e': goto yy24;
        default: goto yy15;
    }
yy20:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'l': goto yy25;
        default: goto yy21;
    }
yy21:
    YYCURSOR = YYMARKER;
    goto yy15;
yy22:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'i': goto yy26;
        default: goto yy21;
    }
yy23:
    yych = *++YYCURSOR;
    switch (yych) {
        case 's': goto yy27;
        default: goto yy21;
    }
yy24:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'r': goto yy28;
        default: goto yy21;
    }
yy25:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'p': goto yy29;
        default: goto yy21;
    }
yy26:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'n': goto yy30;
        default: goto yy21;
    }
yy27:
    yych = *++YYCURSOR;
    switch (yych) {
        case 't': goto yy31;
        default: goto yy21;
    }
yy28:
    yych = *++YYCURSOR;
    switch (yych) {
        case 's': goto yy32;
        default: goto yy21;
    }
yy29:
    yych = *++YYCURSOR;
    if (yych <= 0x00) goto yy33;
    goto yy21;
yy30:
    yych = *++YYCURSOR;
    switch (yych) {
        case '-': goto yy34;
        default: goto yy21;
    }
yy31:
    yych = *++YYCURSOR;
    if (yych <= 0x00) goto yy35;
    goto yy21;
yy32:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'i': goto yy36;
        default: goto yy21;
    }
yy33:
    ++YYCURSOR;
#line 172 "../src/main.ypp"
    {
        try {
            fmt::print(boost::nowide::cout, help_text, *argv);
        } catch (const std::ios_base::failure&) {}
        std::exit(0);
    }
#line 358 "emilua.p/main.cpp"
yy34:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'c': goto yy37;
        default: goto yy21;
    }
yy35:
    ++YYCURSOR;
#line 202 "../src/main.ypp"
    {
        main_context_type = ContextType::test;
        goto opt;
    }
#line 372 "emilua.p/main.cpp"
yy36:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'o': goto yy38;
        default: goto yy21;
    }
yy37:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'o': goto yy39;
        default: goto yy21;
    }
yy38:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'n': goto yy40;
        default: goto yy21;
    }
yy39:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'n': goto yy41;
        default: goto yy21;
    }
yy40:
    yych = *++YYCURSOR;
    if (yych <= 0x00) goto yy42;
    goto yy21;
yy41:
    yych = *++YYCURSOR;
    switch (yych) {
        case 't': goto yy43;
        default: goto yy21;
    }
yy42:
    ++YYCURSOR;
#line 178 "../src/main.ypp"
    {
        try {
            boost::nowide::cout << "Emilua " EMILUA_CONFIG_VERSION_STRING <<
                std::endl << LUAJIT_VERSION << std::endl <<
                "Boost " << (BOOST_VERSION / 100000) << '.' <<
                (BOOST_VERSION / 100 % 1000) << '.' << (BOOST_VERSION % 100) <<
                std::endl <<
#if EMILUA_CONFIG_USE_STANDALONE_ASIO
                "ASIO " << (ASIO_VERSION / 100000) << '.' <<
                (ASIO_VERSION / 100 % 1000) << '.' << (ASIO_VERSION % 100) <<
                std::endl <<
#endif // EMILUA_CONFIG_USE_STANDALONE_ASIO
                std::flush;
        } catch (const std::ios_base::failure&) {}
        std::exit(0);
    }
#line 426 "emilua.p/main.cpp"
yy43:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'e': goto yy44;
        default: goto yy21;
    }
yy44:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'x': goto yy45;
        default: goto yy21;
    }
yy45:
    yych = *++YYCURSOR;
    switch (yych) {
        case 't': goto yy46;
        default: goto yy21;
    }
yy46:
    yych = *++YYCURSOR;
    switch (yych) {
        case '-': goto yy47;
        default: goto yy21;
    }
yy47:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'c': goto yy48;
        default: goto yy21;
    }
yy48:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'o': goto yy49;
        default: goto yy21;
    }
yy49:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'n': goto yy50;
        default: goto yy21;
    }
yy50:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'c': goto yy51;
        default: goto yy21;
    }
yy51:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'u': goto yy52;
        default: goto yy21;
    }
yy52:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'r': goto yy53;
        default: goto yy21;
    }
yy53:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'r': goto yy54;
        default: goto yy21;
    }
yy54:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'e': goto yy55;
        default: goto yy21;
    }
yy55:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'n': goto yy56;
        default: goto yy21;
    }
yy56:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'c': goto yy57;
        default: goto yy21;
    }
yy57:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'y': goto yy58;
        default: goto yy21;
    }
yy58:
    yych = *++YYCURSOR;
    switch (yych) {
        case '-': goto yy59;
        default: goto yy21;
    }
yy59:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'h': goto yy60;
        default: goto yy21;
    }
yy60:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'i': goto yy61;
        default: goto yy21;
    }
yy61:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'n': goto yy62;
        default: goto yy21;
    }
yy62:
    yych = *++YYCURSOR;
    switch (yych) {
        case 't': goto yy63;
        default: goto yy21;
    }
yy63:
    yych = *++YYCURSOR;
    switch (yych) {
        case 0x00: goto yy64;
        case '=': goto yy65;
        default: goto yy21;
    }
yy64:
    ++YYCURSOR;
#line 198 "../src/main.ypp"
    {
        NEXT_ARG("--main-context-concurrency-hint",
                 opt_main_context_concurrency_hint);
    }
#line 561 "emilua.p/main.cpp"
yy65:
    ++YYCURSOR;
#line 194 "../src/main.ypp"
    {
        *cur_arg = YYCURSOR;
        goto opt_main_context_concurrency_hint;
    }
#line 569 "emilua.p/main.cpp"
}
#line 206 "../src/main.ypp"


opt_main_context_concurrency_hint:

#line 576 "emilua.p/main.cpp"
{
    char yych;
    yych = *YYCURSOR;
    switch (yych) {
        case '0': goto yy69;
        case '1': goto yy70;
        case 's': goto yy71;
        default: goto yy67;
    }
yy67:
    ++YYCURSOR;
yy68:
#line 210 "../src/main.ypp"
    { ERRARG("--main-context-concurrency-hint"); }
#line 591 "emilua.p/main.cpp"
yy69:
    yych = *++YYCURSOR;
    if (yych <= 0x00) goto yy72;
    goto yy68;
yy70:
    yych = *++YYCURSOR;
    if (yych <= 0x00) goto yy73;
    goto yy68;
yy71:
    yych = *(YYMARKER = ++YYCURSOR);
    switch (yych) {
        case 'a': goto yy74;
        default: goto yy68;
    }
yy72:
    ++YYCURSOR;
#line 211 "../src/main.ypp"
    {
        main_ctx_concurrency_hint_ = 0;
        goto opt;
    }
#line 613 "emilua.p/main.cpp"
yy73:
    ++YYCURSOR;
#line 215 "../src/main.ypp"
    {
        main_ctx_concurrency_hint_ = 1;
        goto opt;
    }
#line 621 "emilua.p/main.cpp"
yy74:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'f': goto yy76;
        default: goto yy75;
    }
yy75:
    YYCURSOR = YYMARKER;
    goto yy68;
yy76:
    yych = *++YYCURSOR;
    switch (yych) {
        case 'e': goto yy77;
        default: goto yy75;
    }
yy77:
    yych = *++YYCURSOR;
    if (yych >= 0x01) goto yy75;
    ++YYCURSOR;
#line 219 "../src/main.ypp"
    {
#if EMILUA_CONFIG_USE_STANDALONE_ASIO
        main_ctx_concurrency_hint_ = ASIO_CONCURRENCY_HINT_SAFE;
#else // EMILUA_CONFIG_USE_STANDALONE_ASIO
        main_ctx_concurrency_hint_ = BOOST_ASIO_CONCURRENCY_HINT_SAFE;
#endif // EMILUA_CONFIG_USE_STANDALONE_ASIO
        goto opt;
    }
#line 650 "emilua.p/main.cpp"
}
#line 227 "../src/main.ypp"

end:

    if (filename.size() == 0) {
        try {
            boost::nowide::cerr << "missing filename\n";
        } catch (const std::ios_base::failure&) {}
        std::exit(2);
    }

    if (appctx.app_args.size() == 0) {
        appctx.app_args.reserve(2);
        appctx.app_args.emplace_back(argv[0]);
        appctx.app_args.emplace_back(filename);
    }
}

#if BOOST_OS_WINDOWS
extern int (*main_ctx_concurrency_hint)();
static int main_ctx_concurrency_hint2()
#else // BOOST_OS_WINDOWS
int main_ctx_concurrency_hint()
#endif // BOOST_OS_WINDOWS
{
    return main_ctx_concurrency_hint_;
}

#if BOOST_OS_WINDOWS
extern void (*make_master_vm)(
    app_context& appctx, std::shared_ptr<asio::io_context> ioctx);
static void make_master_vm2(
    app_context& appctx, std::shared_ptr<asio::io_context> ioctx)
#else // BOOST_OS_WINDOWS
void make_master_vm(
    app_context& appctx, std::shared_ptr<asio::io_context> ioctx)
#endif // BOOST_OS_WINDOWS
{
    auto vm_ctx = make_vm(*ioctx, appctx, main_context_type,
                          widen_on_windows(filename));
    vm_ctx->ioctxref = ioctx;
    appctx.master_vm = vm_ctx;
    vm_ctx->strand().post([vm_ctx]() {
        vm_ctx->fiber_resume(
            vm_ctx->L(),
            hana::make_set(vm_context::options::skip_clear_interrupter));
    }, std::allocator<void>{});
}

} // namespace emilua::main

int main(int argc, char *argv[], char *envp[])
{
#if BOOST_OS_WINDOWS
    emilua::main::parse_args = emilua::main::parse_args2;
    emilua::main::main_ctx_concurrency_hint =
        emilua::main::main_ctx_concurrency_hint2;
    emilua::main::make_master_vm = emilua::main::make_master_vm2;
#endif // BOOST_OS_WINDOWS
    return emilua::main::main(argc, argv, envp);
}
